#if defined(__APPLE__) 		/* OSX is the only platform to define this (PPC and X86) */
  #include <sys/time.h>
  #include <sys/resource.h>
#endif

#if defined(__linux__)		/* Cairo */ 
	#if defined(__powerpc)
		#include <sys/time.h>
		#include <sys/resource.h>
	#endif
#endif

#if defined(__FreeBSD__)	/* quark */ 
  #include <sys/types.h>
  #include <sys/time.h>
  #include <sys/resource.h>
#endif 

#if defined(__sun__)		/* Millie */ 
	#if defined(__sparc__)
		#include <sys/time.h>
		#include "/usr/ucbinclude/sys/rusage.h"
	#endif
#endif

#if defined(__linux__)		/* ACL */ 
	#if defined(__i386__)
		#include <sys/time.h>
		#include <sys/resource.h>
	#endif
#endif

extern int resource_start( struct timeval *tp_start, struct rusage *r_start );
extern int resource_stop( struct timeval *tp_stop, struct rusage *r_stop ); 
extern void resource_display_delta( struct timeval tp_start, struct rusage r_start, 
                                    struct timeval tp_stop, struct rusage r_stop, 
                                    char label[] ); 
                              
/* 
bubba$ ./array-size 
sizeof(A[0][0]) = 1
iterations x dimension x dimension = visits per traversal
100 x 2885 x 2885 = 832322500
major traversal wtime=16.8634 utime=15.3800 stime=0.1400 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=0 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=0
minor traversal wtime=42.4283 utime=37.7800 stime=0.1800 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=0 majflt=0 nswap=0 inblock=0 outblock=1 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=0

c0$ ./array-size 
sizeof(A[0][0]) = 1
iterations x dimension x dimension = visits per traversal
100 x 2885 x 2885 = 832322500
major traversal wtime=16.1540 utime=16.1175 stime=0.0360 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=2030 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=30
minor traversal wtime=34.8344 utime=34.8347 stime=0.0000 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=0 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=213

quark$ ./array-size 
sizeof(A[0][0]) = 1
iterations x dimension x dimension = visits per traversal
100 x 8191 x 8191 = 2414280804
major traversal wtime=32.4611 utime=32.0479 stime=0.1763 maxrss=66172 ixrss=16496 idrss=49488 isrss=270270464 minflt=16379 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=1337
minor traversal wtime=702.3865 utime=695.6479 stime=1.0275 maxrss=66188 ixrss=373308 idrss=1119924 isrss=1821310976 minflt=1 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=1 nivcsw=39961                                    
                                    
millie$ ./array-size                                 
sizeof(A[0][0]) = 1
iterations x dimension x dimension = visits per traversal
100 x 2895 x 2895 = 838102500
major traversal wtime=53.1678 utime=52.9600 stime=0.0000 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=0 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=2189
minor traversal wtime=88.8764 utime=88.6000 stime=0.0000 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=0 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=2721
               
codd$ ./array-size 
sizeof(A[0][0]) = 1
iterations x dimension x dimension = visits per traversal
100 x 2893 x 2893 = 836944900
major traversal wtime=9.2652 utime=9.2200 stime=0.0500 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=2041 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=0
minor traversal wtime=22.6846 utime=22.5700 stime=0.1100 maxrss=0 ixrss=0 idrss=0 isrss=0 minflt=0 majflt=0 nswap=0 inblock=0 outblock=0 msgsnd=0 msgrcv=0 nsignals=0 nvcsw=0 nivcsw=0
*/ 
